; VCS Control Status:
; $Date:   03 Apr 1991 13:34:22  $
; $Revision:   1.4  $


VERSION equ '1.3'
; add bell for off line and ESC??

;------------------------------------------------------------------------------
;             HPINSTAL.ASM
;
; Replacement for graphics.com for HP III laser printer
;
; Original takes from HPPS.ASM which was a shareware program
;
;       Revision history:
;
; 03 apr 91   using new multiplex interrupt for resident test
;             check for inprogress print screen
; 22 mar 91   original design
;
;----------------------------------------------------------------------------

BiosSeg equ 40h

BIOS_SEG SEGMENT at BiosSeg

        ORG 100h
PrnScrnFlag   db 0

BIOS_SEG ENDS


              .MODEL small
              .386

INCLUDE d:\develop\int2f.h


EXTRN NameTag:byte
EXTRN NameTagSize:abs
EXTRN _newInt05:near
EXTRN _newInt2f:near
EXTRN InstallIDnumber:byte
EXTRN OldInt2f:dword
EXTRN OldInt05:dword
EXTRN PspSegment:word

PUBLIC PrtScrnInstall

;----------------------------------------------------------------------------

              .CODE

ResidentFlag  db 0                        ; variables of resident version
ResidentSeg   dw 0

PrtScrnInstall PROC near


        mov   ax, @code
        mov   ds, ax
        mov   es, ax

        ASSUME ds:@code, es:@code

        mov   ah, 51h                     ; get Psp for ourselves
        int   21h
        mov   PspSegment, bx

        call  ChkResident
        jc    short exit_program

        call  ParseCmdLine
        jc    short exit_program

make_TSR:
        test  ResidentFlag, 1
        jnz   short already_resident

        call  ChkPrnScrn
        jc    short exit_program

        mov   dx,offset install_msg
        mov   ah,09h                      ; print string
        int   21h

        mov   dx,offset _newInt05
        mov   ax,2505h                    ; Set PrtSc int vector
        int   21h

        mov   dx,offset _newInt2f
        mov   ax,252fh                    ; Set Multiplex vector
        int   21h

        mov   es, PspSegment              ; get our PSP
        mov   es,es:[002cH]               ; to get the Env Segment
        mov   ah,49H                      ; and release it
        int   21H

        mov   dx, offset PrtScrnInstall
        add   dx, 0fh
        add   dx, 100h                    ; for Psp size
        shr   dx, 4

        mov   ax,3100h                    ; Terminate but stay resident
        int   21h                         ; bye!

already_resident:
        mov   dx,offset already_msg


exit_program:
        mov   ah, 09h                     ; print exiting message
        int   21h
        mov   ax,4c01h                    ; and exit
        int   21h

PrtScrnInstall ENDP


;-------------------------------------------------------------------------------


help_syntax:
        mov   dx,offset help_msg          ; display syntax
        mov   ah,09h                      ; write string
        int   21h
        mov   ah,4ch                      ; error code from caller in al
        int   21h



;-------------------------------------------------------------------------------
; Examines the command line for possible args. Exit with CARRY if no going
; resident and message in dx to pring.

ParseCmdLine PROC near

        ASSUME  ds:@code,es:@code

        push  ds
        mov   ds, PspSegment

        ASSUME ds:NOTHING

        mov   cl,ds:[80h]                 ; parse command line switches
        xor   ch,ch
        mov   si, 81h                     ; beginning of text on cmd line
        jcxz  short ok_exit
        mov   si,81h                      ; command line buffer


parm_loop:
        lodsb                             ; get byte
        cmp   al,'/'                      ; option switch?
        jz    short get_option
        cmp   al,'-'                      ; option switch?
        jz    short get_option
        cmp   al,' '                      ; space
        jz    short get_next
        cmp   al,09h                      ; tab
        jnz   short bad_parm

get_next:
        loop  parm_loop
        jmp   short ok_exit



get_option:
        lodsb                             ; get option
        dec   cx                          ; adjust command char count
        cmp   al,'u'
        je    short uninstall
        cmp   al,'U'
        je    short uninstall
        cmp   al,'h'
        je    short do_help
        cmp   al,'H'
        je    short do_help
        cmp   al,'?'
        je    short do_help
bad_parm:
        mov   dx,offset bad_parm_msg
        jmp   short fail_exit

do_help:
        mov   dx,offset help_msg          ; display syntax
        jmp   short fail_exit

uninstall:
        push  cs
        pop   ds

        ASSUME ds:@code

        test  ResidentFlag, 1
        jz    short not_there

        call  TSRchkVectors
        jc    short fail_vectors

        call  TSRremove
        jc    short fail_remove

        mov   dx, offset ok_remove_msg
        jmp   short ok_no_tsr

fail_vectors:
        mov   dx, offset bad_vectors_msg
        jmp   short fail_exit

fail_remove:
        mov   dx, offset bad_remove_msg
        jmp   short fail_exit

not_there:
        mov   dx, offset bad_uninstall_msg
        jmp   short fail_exit



ok_no_tsr:
        mov   al, 0
        stc
        jmp   short exit

fail_exit:
        mov   al, 1
        stc
        jmp   short exit

ok_exit:
        clc
exit:
        pop   ds
        ret

ParseCmdLine ENDP

;-------------------------------------------------------------------------------
; Removes the resident version which has been checked as being ok. First get
; its old int5 which was stored when going resident to release the vector hook,
; then remove its memory. Final memory release passes CARRY state to caller.


TSRremove PROC near

        ASSUME ds:@code, es:@code

        push  es
        push  ds
        push  dx

        mov   es, ResidentSeg             ; code segment of resident version

        ASSUME es:NOTHING                 ; es=Resident Segment

        lds   dx, es:OldInt05             ; get its sense of original vector
        mov   ax, 2505h                   ; install old vector
        int   21h

        lds   dx, es:OldInt2f             ; get its sense of original vector
        mov   ax, 252fh                   ; install old vector
        int   21h

        mov   es, es:PspSegment
        mov   ah, 49h                     ; release memory
        int   21h

        pop   dx
        pop   ds
        pop   es

        ret

TSRremove ENDP

;-------------------------------------------------------------------------------
; Check that those vectors in the vector table are those of ourselves so that
; we can unhook them. They should point to the installed TSR version

TSRchkVectors PROC near

        push  ax
        push  es
        push  bx

        ASSUME ds:@code, es:@code

        mov   ax, 3505h                   ; es:bx response
        int   21h

        ASSUME es:NOTHING

        cmp   bx, offset _newInt05
        jne   short bad_vector
        mov   bx, es
        cmp   bx, ResidentSeg
        jne   short bad_vector

        mov   ax, 352fh                   ; es:bx response
        int   21h

        ASSUME es:NOTHING

        cmp   bx, offset _newInt2f
        jne   short bad_vector
        mov   bx, es
        cmp   bx, ResidentSeg
        jne   short bad_vector
        clc
        jmp   short @F

bad_vector:
        stc
@@:
        pop   bx
        pop   es
        pop   ax
        ret

TSRchkVectors ENDP

;-------------------------------------------------------------------------------
; Checks if resident using the multiplex int 2f with our ID number. If no
; response not installed. If response confirm that it is us by checking the
; nameTag. If not us bump the ID and keep trying till (1) no response, (2)
; it is us, or (3) no more ID's left. Last case exit with CARRY to abort,
; else NOCARRY. The install state is recorded in ResidentFlag. Preserve full
; context through this function.

ChkResident PROC near

        ASSUME  ds:@code,es:@code

        pusha
        push  es

next_call_try:
        mov   ah, InstallIDnumber         ; use default ID number
        mov   al, 0                       ; clear response flag
        int   2fh                         ; call to world
        cmp   al, 0ffh                    ; check response flag
        jne   short not_resident          ; if not there exit


        ASSUME es:NOTHING

        mov   ResidentSeg, bx             ; store its segment
        mov   es, bx                      ; else confirm that it us
        mov   cx, NameTagSize             ; by comparing tag names
        mov   si, offset NameTag
        mov   di, si
        repe  cmpsb
        sete  ResidentFlag                ; set flag if there
        je    short @F                    ; ok, it is us installed

        inc   InstallIDnumber             ; try next number in sequence
        jnz   next_call_try               ; keep try till no more numbers

        mov   dx, offset no_id_msg        ; failed message and CARRY
        stc
        jmp   short @F


not_resident:
        mov   ax, 3505h                   ; get vector
        int   21h

        ASSUME es:NOTHING

        mov   word ptr OldInt05, bx
        mov   word ptr OldInt05[2], es    ; es: resident verions

        mov   ax, 352fh                   ; get vector
        int   21h

        mov   word ptr OldInt2f, bx
        mov   word ptr OldInt2f[2], es    ; es: resident verions


        clc
@@:
        pop   es
        popa
        ret

ChkResident ENDP

;-------------------------------------------------------------------------------
; See if a print screen is in progress before installing

ChkPrnScrn PROC near

        ASSUME  ds:@code,es:@code

        push  ds
        push  ax

        mov   ax, BiosSeg
        mov   ds, ax

        ASSUME ds:BIOS_SEG

        cmp   PrnScrnFlag, 1      ; test flag
        je    short in_progress
        mov   PrnScrnFlag, 0      ; clear out 0ffh as error case
        clc
        jmp   short @F

in_progress:
        mov   dx, offset prn_scrn_msg
        stc

@@:
        pop   ax
        pop   ds

        ret
ChkPrnScrn ENDP


;-------------------------------------------------------------------------------

install_msg:
        db 0ah, 0dh
        db 'HPGRAPH: Successfully install print screen graphic driver, version ', VERSION
        db  0dh, 0ah,'$'

ok_remove_msg:
        db 0ah, 0dh
        db 'HPGRAPH: Successfully removed resident graphics drive.'
        db  0dh, 0ah,'$'
help_msg:
        db 0dh, 0ah
        db 'HPGRAPH: syntax',0dh,0ah
        db '   -h or /H = help info', 0dh, 0ah
        db '   -u or /U = uninstall', 0dh, 0ah,'$'

bad_parm_msg:
        db 07,0ah, 0dh
        db 'HPGRAPH: Illegal parameter.'
        db 0dh, 0ah,'$'

bad_uninstall_msg:
        db 07,0ah, 0dh
        db 'HPGRAPH: Not resident, cannot uninstall.'
        db 0dh, 0ah,'$'

bad_remove_msg:
        db 07,0ah, 0dh
        db 'HPGRAPH: Failed to remove from memory, vectors uninstalled.'
        db 0dh, 0ah,'$'

bad_vectors_msg:
        db 07,0ah, 0dh
        db 'HPGRAPH: Failed to remove interrupt vectors, not uninstalled.'
        db 0dh, 0ah,'$'

already_msg:
        db 07,0ah, 0dh
        db 'HPGRAPH: Already resident, not installed again.'
        db 0dh, 0ah,'$'

no_id_msg:
        db 07,0ah, 0dh
        db 'HPGRAPH: No free multiplex ID numbers available.'
        db 0dh, 0ah,'$'

prn_scrn_msg:
        db 07,0ah, 0dh
        db 'HPGRAPH: PrintScreen in program, not installed.'
        db 0dh, 0ah,'$'

;-------------------------------------------------------------------------------
        END PrtScrnInstall
