; VCS Control Status:
; $Date:   03 Apr 1991 13:34:00  $
; $Revision:   1.13  $
;------------------------------------------------------------------------------
;             HPINT5.ASM
;
; Replacement for graphics.com for HP III laser printer
;
; Original taken from HPPS.ASM which was a shareware program
;
;       Revision history:
;
; 03 apr 91   added use of multiplex interrupt for exists
; 26 mar 91   added visual indication of graphics mode printing
; 22 mar 91   original design
;
;----------------------------------------------------------------------------
; Functional replacement of graphics.com to do all print screen functions for
; HP laser printer. Supports all video graphics modes. Uses defined sizes
; for each mode except text mode gets row count from low memory bios for
; non-standard screen heights. In graphics mode, pixel value reads are done
; through the Bios not hardware. Assembled for .386 but easy to modify for
; 286, i.e. use of fs register. Prints in landscape mode by scanning screen
; from lower left upwards on successive screen lines since printer does
; graphics from left to right horizontally.
;
; Display result is data drive for each mode.

INCLUDE d:\develop\int2f.h


BiosSeg SEGMENT at 40h

        ORG 6ch
BiosTimer      dd ?

        ORG  84h
BiosRows      db ?

BiosSeg ENDS


;----------------------------------------------------------------------------

              .MODEL small
              .386
              .CODE

PUBLIC _newInt05
PUBLIC _newInt2F
PUBLIC InstallIDnumber
PUBLIC OldInt2f
PUBLIC OldInt05
PUBLIC PspSegment

PUBLIC NameTag
PUBLIC NameTagSize
INCLUDE d:\develop\63xx.h

LAST_VIDEO_MODE equ 13h

LPT1 equ 0
START_BELL_FREQ    equ   180h         ; special frequency
BELL_FREQ_CHANGE   equ    40h
LAST_BELL_FREQ     equ   140h
BELL_TIME_INTERVAL equ    30
WAIT_TIME_OUT      equ   10*BELL_TIME_INTERVAL +1
BLANK_COLOR        equ   0fh
DOT_INTERVAL       equ   20h

; normal ok status     = 90h = PRN_NOT_BUSY or PRN_SELECTED
; no paper but on line = 28h = PRN_NO_PAPER or PRN_IO_ERROR
; off line state       = 8h  = PRN_IO_ERROR

PRN_NOT_BUSY  equ 80h
PRN_ACKNOWLDG equ 40h
PRN_NO_PAPER  equ 20h
PRN_SELECTED  equ 10h
PRN_IO_ERROR  equ 08h
PRN_TIME_OUT  equ 01h

;----------------------------------------------------------------------------

OldInt2f      dd 0
OldInt05      dd 0                ; which can be read by externally
PspSegment    dw 0

InstallIDnumber   db GRAPHICS_EXE_ID
NameTag db 'HPGRAPH.COM ver 1.0'
NameTagSize equ $ - offset NameTag

; Video Graphics Compinations supported: 320x200, 640x200, 640x350, 640x480


ColArray:       ; nominal column size defined for mode
        dw 40                         ; 0
        dw 40                         ; 1
        dw 80                         ; 2
        dw 80                         ; 3
        dw 320                        ; 4     320x200
        dw 320                        ; 5     320x200
        dw 640                        ; 6     640x200
        dw 80                         ; 7
        dw 0                          ; 8
        dw 0                          ; 9
        dw 0                          ; A
        dw 0                          ; B
        dw 0                          ; C
        dw 320                        ; D     320x200
        dw 640                        ; E     640x200
        dw 640                        ; F     640x350
        dw 640                        ; 10    640x350
        dw 640                        ; 11    640x480
        dw 640                        ; 12    640x480
        dw 320                        ; 13    320x200


RowArray:       ; nominal row size defined for video modes only
        dw 0                          ; 0
        dw 0                          ; 1
        dw 0                          ; 2
        dw 0                          ; 3
        dw 200                        ; 4     320x200
        dw 200                        ; 5     320x200
        dw 200                        ; 6     640x200
        dw 0                          ; 7
        dw 0                          ; 8
        dw 0                          ; 9
        dw 0                          ; A
        dw 0                          ; B
        dw 0                          ; C
        dw 200                        ; D     320x200
        dw 200                        ; E     640x200
        dw 350                        ; F     640x350
        dw 350                        ; 10    640x350
        dw 480                        ; 11    640x480
        dw 480                        ; 12    640x480
        dw 200                        ; 13    320x200


MultArray:      ; duplication cnt (col,row) in various modes
        dw 0                          ; 0
        dw 0                          ; 1
        dw 0                          ; 2
        dw 0                          ; 3
        dw 202h                       ; 4     320x200
        dw 202h                       ; 5     320x200
        dw 102h                       ; 6     640x200
        dw 0                          ; 7
        dw 0                          ; 8
        dw 0                          ; 9
        dw 0                          ; A
        dw 0                          ; B
        dw 0                          ; C
        dw 202h                       ; D     320x200
        dw 102h                       ; E     640x200
        dw 101h                       ; F     640x350
        dw 101h                       ; 10    640x350
        dw 101h                       ; 11    640x480
        dw 101h                       ; 12    640x480
        dw 202h                       ; 13    320x200


FunctArray:     ; called function for each mode
        dw PrintText                  ; 0
        dw PrintText                  ; 1
        dw PrintText                  ; 2
        dw PrintText                  ; 3
        dw PrintGraphics              ; 4     320x200
        dw PrintGraphics              ; 5     320x200
        dw PrintGraphics              ; 6     640x200
        dw PrintText                  ; 7
        dw NullFunction               ; 8
        dw NullFunction               ; 9
        dw NullFunction               ; A
        dw NullFunction               ; B
        dw NullFunction               ; C
        dw PrintGraphics              ; D     320x200
        dw PrintGraphics              ; E     640x200
        dw PrintGraphics              ; F     640x350
        dw PrintGraphics              ; 10    640x350
        dw PrintGraphics              ; 11    640x480
        dw PrintGraphics              ; 12    640x480
        dw PrintGraphics              ; 13    320x200


hp_InitArray:   ; initialization escape string ptrs
        dw offset hp_init40Text       ; 0
        dw offset hp_init40Text       ; 1
        dw offset hp_init80Text       ; 2
        dw offset hp_init80Text       ; 3
        dw offset hp_init320x200      ; 4     320x200
        dw offset hp_init320x200      ; 5     320x200
        dw offset hp_init640x200      ; 6     640x200
        dw offset hp_init80Text       ; 7
        dw offset hp_null             ; 8
        dw offset hp_null             ; 9
        dw offset hp_null             ; A
        dw offset hp_null             ; B
        dw offset hp_null             ; C
        dw offset hp_init320x200      ; D     320x200
        dw offset hp_init640x200      ; E     640x200
        dw offset hp_init640x350      ; F     640x350
        dw offset hp_init640x350      ; 10    640x350
        dw offset hp_init640x480      ; 11    640x480
        dw offset hp_init640x480      ; 12    640x480
        dw offset hp_init320x200      ; 13    320x200


hp_LineArray:   ; line header escape sequence ptrs
        dw offset hp_line40Text       ; 0
        dw offset hp_line40Text       ; 1
        dw offset hp_line80Text       ; 2
        dw offset hp_line80Text       ; 3
        dw offset hp_line320x200      ; 4     320x200
        dw offset hp_line320x200      ; 5     320x200
        dw offset hp_line640x200      ; 6     640x200
        dw offset hp_line80Text       ; 7
        dw offset hp_null             ; 8
        dw offset hp_null             ; 9
        dw offset hp_null             ; A
        dw offset hp_null             ; B
        dw offset hp_null             ; C
        dw offset hp_line320x200      ; D     320x200
        dw offset hp_line640x200      ; E     640x200
        dw offset hp_line640x350      ; F     640x350
        dw offset hp_line640x350      ; 10    640x350
        dw offset hp_line640x480      ; 11    640x480
        dw offset hp_line640x480      ; 12    640x480
        dw offset hp_line320x200      ; 13    320x200


hp_EndArray:    ; terminating escape sequence ptrs
        dw offset hp_endText          ; 0
        dw offset hp_endText          ; 1
        dw offset hp_endText          ; 2
        dw offset hp_endText          ; 3
        dw offset hp_endGraphic       ; 4     320x200
        dw offset hp_endGraphic       ; 5     320x200
        dw offset hp_endGraphic       ; 6     640x200
        dw offset hp_endText          ; 7
        dw offset hp_null             ; 8
        dw offset hp_null             ; 9
        dw offset hp_null             ; A
        dw offset hp_null             ; B
        dw offset hp_null             ; C
        dw offset hp_endGraphic       ; D     320x200
        dw offset hp_endGraphic       ; E     640x200
        dw offset hp_endGraphic       ; F     640x350
        dw offset hp_endGraphic       ; 10    640x350
        dw offset hp_endGraphic       ; 11    640x480
        dw offset hp_endGraphic       ; 12    640x480
        dw offset hp_endGraphic       ; 13    320x200


IntBusy       db 0        ; re-entrant trap flag
VideoPage     db 0        ; current video page
VideoMode     db 0        ; current video Mode
VideoCols     db 0        ; current column on screen
ScrnRows      dw 0        ; Number of rows-1 for this mode
ScrnCols      dw 0        ; Number of columns-1 for this mode
RowDupFactor  db 0        ; Duplicates pixels in row direction
ColDupFactor  db 0        ; Duplicates pixels in col direction
hp_InitPtr    dw 0        ; HP initialize escape sequence
hp_LinePtr    dw 0        ; HP line start escape sequence
hp_EndPtr     dw 0        ; HP terminating escape sequence

PrnCounter    dw 0
LineBuffer    db 60 dup(0)
VertBuffer    db (480/DOT_INTERVAL+1) dup(0)


;-------------------------------------------------------------------------------

hp_null       db ' '                  ; dummy string

;...............................................................................

hp_init640x480:
              db 'E'                 ; RESET
              db '9'                 ; CLEAR MARGIN
              db '&l0O'              ; PORTRATE
              db '&a640h540V'        ; POSITION CURSOR HORZ + VERT DECIPNTS
              db '*t75R'             ; RASTER RESOLUTION
              db '*r1A',0            ; START RASTER CURRENT CURSOR

hp_init640x350:
              db 'E'                 ; RESET
              db '9'                 ; CLEAR MARGIN
              db '&l0O'              ; PORTRATE
              db '&a1180h540V'       ; POSITION CURSOR HORZ + VERT DECIPNTS
              db '*t75R'             ; RASTER RESOLUTION
              db '*r1A',0            ; START RASTER CURRENT CURSOR

hp_init640x200:
hp_init320x200:
              db 'E'                 ; RESET
              db '9'                 ; CLEAR MARGIN
              db '&l0O'              ; PORTRATE
              db '&a940h540V'        ; POSITION CURSOR HORZ + VERT DECIPNTS
              db '*t75R'             ; RASTER RESOLUTION
              db '*r1A',0            ; START RASTER CURRENT CURSOR

hp_init40Text:
hp_init80Text:
              db 'E'                 ; RESET
              db '9'                 ; CLEAR MARGIN
              db '(10U'              ; PC-8
              db '(s0p10H',0         ; FIXED SPACING, PRIMARY PITCH

;...............................................................................

hp_line40Text:
hp_line80Text:
              db 0dh, 0ah,0           ; CR+LF

hp_line640x480:
              db '*b60W',0           ; XFER RASTER, BYTE CNT

hp_line640x350:
              db '*b44W',0           ; XFER RASTER, BYTE CNT

hp_line640x200:
hp_line320x200:
              db '*b50W',0           ; XFER RASTER, BYTE CNT (doubled)


;...............................................................................
; we end with a reset to leave the printer in a defined state and also
; disable the final FormFeed from the caller if there


hp_endText:
              db '&a0C'              ; COLUMN 0
              db 0ch,0                ; FORM_FEED
              db 'E',0               ; RESET

hp_endGraphic:
              db '*rB'               ; END GRAPHICS
              db '&a0C'              ; COLUMN 0
              db 0ch,0                ; FORM_FEED
              db 'E',0               ; RESET


;-------------------------------------------------------------------------------


_newInt2F PROC far

        ASSUME ds:NOTHING, es:NOTHING

        cmp     ah,InstallIDnumber
        je      short us_multiplex
        jmp     OldInt2f
us_multiplex:
        or      al,al             ; see if somebody answered already
        jnz     short prior_answer
        mov     bx,cs             ; else we answer
        mov     al,0FFh           ; answer flag = 0FFh

prior_answer:
        iret

_newInt2F ENDP

;-------------------------------------------------------------------------------


_newInt05 PROC far

        ASSUME ds:NOTHING, es:NOTHING

        cmp     Intbusy,0             ; Continue if not busy
        jz      short go_ahead
        iret

go_ahead:
        inc   IntBusy                 ; Set busy, block re-entrants
        sti                           ; let the dogs back in

        push  ax                      ; save state
        push  bx
        push  cx
        push  dx
        push  bp
        push  si
        push  di
        push  ds
        push  es
        push  fs

        mov   ax,cs                   ; setup ds,es
        mov   ds,ax
        mov   es,ax
        mov   ax, BiosSeg
        mov   fs, ax

        ASSUME  ds:@code,es:@code, fs:BiosSeg

        cld                           ; set direction flag

        mov   ah,0fh                  ; Get video mode
        int   10h
        mov   VideoMode,al
        mov   VideoCols,ah
        mov   VideoPage,bh

        cmp   al, LAST_VIDEO_MODE     ; protect table if beyond last
        ja    short exit

        mov   bl, VideoMode
        xor   bh, bh
        shl   bx, 1                   ; word index into table
        add   bx, offset FunctArray
        call  [bx]

exit:
        pop   fs                      ; Restore state
        pop   es
        pop   ds
        pop   di
        pop   si
        pop   bp
        pop   dx
        pop   cx
        pop   bx
        pop   ax

        ASSUME ds:NOTHING, es:NOTHING, fs:NOTHING

        cli
        dec   IntBusy                 ; Clear busy
        iret

_newInt05 ENDP

;-------------------------------------------------------------------------------
; Main graphics screen print function. Scans top to bottom on screen but output
; to printer horizontal to get portrate mode.

PrintGraphics PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        ; Initialize required data for this
        ; video graphics mode.

        call  InitModeData

        ; init graphics mode to place
        ; laser printer into defined state

        mov   bx, hp_InitPtr
        call  PrintZstring
        jc    short failed_prn

        mov   cx,0                    ; Scrn column index = 0

pg_nextCol:
        mov   di, offset LineBuffer
        mov   PrnCounter, 0
        mov   dx, ScrnRows            ; Scrn row index = bottom

pg_nextByte:
        mov   bh, 1                   ; init composing byte to LSB

pg_nextBit:
        call  ReadPixelDot            ; read the next dot at (row,col)

        mov   bl, al                  ; new value moved to bl
        shl   bx, 1                   ; move in that bit to LSB of bh
        jnc   pg_nextBit              ; if not done get next bit

        mov   al,bh                   ; store composed byte
        stosb                         ; into LineBuffer
        inc   PrnCounter              ; update counter

        cmp   dx, 0                   ; see if at top yet, end of scan
        jge   pg_nextByte             ; loop if not

        call  VisualFeedback          ; show user status

        call  PrintLine               ; line done, print it
        jc    short failed_prn

        inc   cx                      ; add one to col counter
        cmp   cx,ScrnCols             ; compare to max value
        jle   pg_nextCol              ; continue until finished with all cols

        ; close of graphics mode
        ; since we are fully done

        mov   bx, hp_EndPtr
        call  PrintZstring

failed_prn:
        ret


PrintGraphics ENDP

;-------------------------------------------------------------------------------
; Initialize required data for this video graphics mode by indexing to arrays
; to extract the data for this run. Includes ScrnRows, ScrnCols, RowDUpFactor,
; ColDupFactor, hp_InitPtr, hp_LinePtr, and hp_EndPtr

InitModeData PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        mov   bl, VideoMode               ; get the video mode as index
        xor   bh,bh
        shl   bx, 1                       ; make a word ptr

        mov   ax, word ptr RowArray[bx]   ; get array value of row cnt
        dec   ax                          ; convert to row-1
        jge   short @F                    ; if array=0, use Bios
        mov   al, BiosRows
        xor   ah, ah
@@:     mov   ScrnRows, ax

        mov   ax, word ptr ColArray[bx]   ; get array value of col cnt
        dec   ax                          ; convert to col-1
        mov   ScrnCols, ax                ; to init Cols variable

        mov   ax, word ptr hp_InitArray[bx]
        mov   hp_InitPtr, ax

        mov   ax, word ptr hp_LineArray[bx]
        mov   hp_LinePtr, ax

        mov   ax, word ptr hp_EndArray[bx]
        mov   hp_EndPtr, ax

        mov   ax, word ptr MultArray[bx]
        mov   RowDupFactor, al
        mov   ColDupFactor, ah

        ret

InitModeData ENDP

;-------------------------------------------------------------------------------
; Prints a data line starting with predefined header and then the buffer for
; line. Preserves all registers. Repeats line based on col repeat factor. Traps
; for defective 0 cnt in either the line data or the repeat factor. No error
; test for match between number of bytes and HP escape count in ascii format!

PrintLine PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        push  cx
        push  bx

        xor   ch,ch
        mov   cl, ColDupFactor        ; bx = line repeat factor
        jcxz  short exit_line         ; trap for 0 cnt

line_repeat:

        mov   bx, hp_LinePtr          ; printer line header information
        call  PrintZstring
        jc    short exit_line

        push  cx                      ; save repeat counter
        mov   si, offset LineBuffer   ; setup to head of line buffer
        mov   cx, PrnCounter          ; count of byte in buffer
        jcxz  short exit_data         ; trap for 0 cnt
byte_loop:
        lodsb                         ; get byte
        call  PrintChar               ; print it
        jnc   short @F                ; if ok continue
        pop   cx                      ; else cleanup stack
        jmp   short exit_line         ; and exit
@@:     loop  byte_loop               ; until all done

exit_data:
        pop   cx                      ; dec repeat counter
        loop  line_repeat             ; again if more lines to do
        clc                           ; normal exit

exit_line:
        pop   bx
        pop   cx
        ret


PrintLine ENDP

;------------------------------------------------------------------------------
; Prints the string defined by bx pointer until terminating NULL.

PrintZstring PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

prn_next_byte:
        mov   al,[bx]         ; print string at bx to printer
        or    al,al
        jz    short prn_exit
        call  PrintChar
        jc    short prn_exit
        inc   bx
        jmp   short prn_next_byte

prn_exit:
        ret

PrintZstring ENDP

;------------------------------------------------------------------------------
; print single char in al. Tests status first since time out is very long
; or never and we loose control.

PrintChar PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        push  dx
        mov   dx, LPT1                ; dx=0 for LPT 1

        call  PrnStatus
        jc    short exit_prn

        mov   ah, 00h                 ; function to print a char in al
        int   17h                     ; do it,

exit_prn:
        pop   dx
        ret

PrintChar ENDP

;------------------------------------------------------------------------------
; Examines for ok status and if not enters a wait/bell loop till we give up
; dx has the LPT1 value.

set_time      dw 0        ; local variables initialized here and RingBell()
last_time     dw 0
bell_freq     dw 0

PrnStatus PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg


        mov   ah, 02h                 ; function printer status
        int   17h                     ; get status
        test  ah, (PRN_IO_ERROR or PRN_NO_PAPER or PRN_TIME_OUT)
        jz    short ok_status         ; if ok just leave

        push  ax
        mov   ax, word ptr BiosTimer  ; setup current time
        mov   set_time,ax             ; in our variable
        mov   last_time,ax            ; in our variable
        mov   bell_freq, START_BELL_FREQ
        pop   ax

test_again:
        call  AlertUser               ; ring bell
        jc    short exit_status       ; if timeout exit
        mov   ah, 02h                 ; function printer status
        int   17h                     ; get status
        test  ah, (PRN_IO_ERROR or PRN_NO_PAPER or PRN_TIME_OUT)
        jnz   test_again

ok_status:
        clc
exit_status:
        ret

PrnStatus ENDP

;------------------------------------------------------------------------------
; Determines how long has gone by and ring bell at interval, if too long
; failed exit.

AlertUser PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        push  bx
        push  ax

        mov   bx, word ptr BiosTimer
        mov   ax, bx
        sub   ax, last_time
        cmp   ax, BELL_TIME_INTERVAL
        jle   short continue

        mov   ax, bx
        sub   ax, set_time
        cmp   ax, WAIT_TIME_OUT
        jl    short @F
        mov   bell_freq, LAST_BELL_FREQ
@@:
        pushf
        mov   last_time, bx
        mov   ax, KEYBOARD_BELL
        mov   bx, bell_freq
        int   21h
        add   bell_freq, BELL_FREQ_CHANGE
        popf

        jl    short continue
        stc
        jmp   short bell_exit

continue:
        clc
bell_exit:
        pop   ax
        pop   bx
        ret

AlertUser ENDP

;------------------------------------------------------------------------------
; Read the color value of the pixel specified by cx=horz, dx=vert, returns
; color in al and map to 1 bit. Advance row ptr in dx upwards by decrementing.
; Supports repeating data using internal repeat_cnt and store of last pixel.
; Traps for request of data above top of screen when rows is not a multiple of
; 8

last_pixel    db 0
repeat_cnt    db 1

ReadPixelDot PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        dec   repeat_cnt              ; update repeat counter and if 0
        jz    short get_next          ; time to get new value
        mov   al, last_pixel          ; else get previous one and
        jmp   short exit_pixel        ; leave

get_next:
        mov   al, RowDupFactor        ; update repeat_cnt to initial value
        mov   repeat_cnt, al

        xor   al,al                   ; trap out beyond left border
        cmp   dx, 0                   ; with forced 0 return
        jl    short null_read

        push  bx                      ; save bx
        mov   bh, VideoPage           ; setup video page
        mov   ah, 0dh                 ; read pixel @ cx=horz, dx=vert
        int   10h                     ; and restore bx
        pop   bx

null_read:

        dec   dx                      ; increment the scrn row index
        and   al,0ffh                 ; convert color value to binary bit
        jz    short @F
        mov   al,0ffh                 ; else fill the byte
@@:
        mov   last_pixel, al          ; save for possible repeat


exit_pixel:

        ret

ReadPixelDot ENDP

;------------------------------------------------------------------------------
; Store the screen line specified by cx into temp buffer and blank it out
; for visual feedback

VisualFeedback PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        push  di
        push  si
        push  dx
        push  bx
        push  cx

        mov   di, offset VertBuffer
        mov   si, offset VertBuffer
        mov   dx, DOT_INTERVAL/2      ; column start value
        mov   bh, VideoPage           ; setup video page
        mov   ah, 0ch                 ; write pixel @ cx=horz, dx=vert

next_dot:
        ; restore screen from
        ; buffer if on screen
        lodsb                         ; get prev pixel
        dec   cx                      ; set to prev col
        jl    short @F                ; skip if off screen
        int   10h                     ; write pixel
@@:
        inc   ah                      ; 0dh= read pixel @ cx=horz, dx=vert
        inc   cx                      ; back to current col
        int   10h                     ; get pixel color
        stosb                         ; and store

        dec   ah                      ; 0ch= write pixel @ cx=horz, dx=vert
        cmp   cx, ScrnCols            ; skip blank of last col
        jge   short @F
        mov   al, BLANK_COLOR         ; replacement color
        int   10h                     ; overwrite
@@:
        add   dx, DOT_INTERVAL        ; next buffer slot
        cmp   dx, ScrnRows            ; loop if not done
        jle   next_dot


        pop   cx
        pop   bx
        pop   dx
        pop   si
        pop   di

        ret

VisualFeedback ENDP

;------------------------------------------------------------------------------
; Read the character value and attribute at cursor location, returns value in
; al, attribute in ah

ReadScrnChar PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        push  bx
        mov   bh, VideoPage           ; setup video page
        mov   ah, 08h                 ; read char @ cx=horz, dx=vert
        int   10h
        pop   bx
        ret

ReadScrnChar ENDP



;------------------------------------------------------------------------------
; Main Text print screen routine

old_cursor    dw  0

PrintText PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        call  GetCursorPos
        mov   old_cursor, dx          ; save for exit restore

        ; Initialize required data for this
        ; video text mode.

        call  InitModeData

        ; init text mode to place
        ; laser printer into defined state

        mov   bx, hp_InitPtr
        call  PrintZstring
        jc    short exit_text

        ; init outer row loop for screen
        ; scan of text chars

        mov   dh, 0                   ; set cursor row=0

pt_nextRow:

        mov   bx, hp_LinePtr
        call  PrintZstring
        jc    short exit_text
        mov   dl, 0                   ; set cursor column = 0

pt_nextCol:
        call  SetCursorPos            ; position cursor to target char
        call  ReadScrnChar            ; read its value in al
        call  PrintChar               ; sent to printer
        jc    short exit_text
        inc   dl
        cmp   dl, byte ptr ScrnCols
        jle   pt_nextCol

        inc   dh
        cmp   dh, byte ptr ScrnRows
        jle   pt_nextRow

        ; close of text mode
        ; since we are fully done

        mov   bx, hp_EndPtr
        call  PrintZstring            ; CARRY is result

exit_text:
        pushf                         ; save CARRY across call
        mov   dx, old_cursor          ; get orignal cursor location
        call  SetCursorPos
        popf                          ; restore CARRY
        ret

PrintText ENDP

;-------------------------------------------------------------------------------
; Get screen cursor position returned in dl=col, dh=row

GetCursorPos PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        push  bx
        mov   ah, 03h                 ; get current cursor location
        mov   bh, VideoPage
        int   10h
        pop   bx

        ret

GetCursorPos ENDP

;-------------------------------------------------------------------------------
; Set screen cursor to position specified in dl=col, dh=row

SetCursorPos PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        push  bx
        mov   ah,02h                  ; prepare to restore cursor
        mov   bh, VideoPage
        int   10h
        pop   bx

        ret

SetCursorPos ENDP


;-------------------------------------------------------------------------------

NullFunction PROC near

        ASSUME  ds:@code,es:@code,fs:BiosSeg

        stc
        ret
NullFunction ENDP

;-------------------------------------------------------------------------------
        END
